GIT-HYPER-BLAME(1)

NAME
git-hyper-blame - Like git blame, but with the ability to ignore or bypass certain commits.

SYNOPSIS

git hyper-blame [-i <rev> [-i <rev> ...]] [--ignore-file=<file>]
                [--no-default-ignores] [<rev>] [--] <file>

DESCRIPTION

git hyper-blame is like git blame but it can ignore or "look through" a given set of commits, to find the real culprit.

This is useful if you have a commit that makes sweeping changes that are unlikely to be what you are looking for in a blame, such as mass reformatting or renaming. By adding these commits to the hyper-blame ignore list, git hyper-blame will look past these commits to find the previous commit that touched a given line.

Follows the normal blame syntax: annotates <file> with the revision that last modified each line. Optional <rev> specifies the revision of <file> to start from.

Automatically looks for a file called .git-blame-ignore-revs in the repository root directory. This file has the same syntax as the --ignore-file argument, and any commits mentioned in this file are added to the ignore list.

OPTIONS

-i <rev>
    A revision to ignore. Can be specified as many times as needed.

--ignore-file=<file>
    A file containing a list of revisions to ignore. Can have comments beginning with #.

--no-default-ignores
    Do not ignore commits from the .git-blame-ignore-revs file.

EXAMPLE

Let’s run git blame on a file:

    $ git blame ipsum.txt
    c6eb3bfa (lorem           2014-08-11 23:15:57 +0000 1) LOREM IPSUM DOLOR SIT AMET, CONSECTETUR
    3ddda43c (auto-uppercaser 2014-07-05 02:05:18 +0000 2) ADIPISCING ELIT, SED DO EIUSMOD TEMPOR
    3ddda43c (auto-uppercaser 2014-07-05 02:05:18 +0000 3) INCIDIDUNT UT LABORE ET DOLORE MAGNA
    3ddda43c (auto-uppercaser 2014-07-05 02:05:18 +0000 4) ALIQUA. UT ENIM AD MINIM VENIAM, QUIS
    c6eb3bfa (lorem           2014-08-11 23:15:57 +0000 5) NOSTRUD EXERCITATION ULLAMCO LABORIS
    3ddda43c (auto-uppercaser 2014-07-05 02:05:18 +0000 6) NISI UT ALIQUIP EX EA COMMODO CONSEQUAT.

Notice that almost the entire file has been blamed on a formatting change? You aren’t interested in the uppercasing of the file. You want to know who wrote/modified those lines in the first place. Just tell hyper-blame to ignore that commit:

    $ git hyper-blame -i 3ddda43c ipsum.txt
    c6eb3bfa (lorem 2014-08-11 23:15:57 +0000  1) LOREM IPSUM DOLOR SIT AMET, CONSECTETUR
    134200d1 (lorem 2014-04-10 08:54:46 +0000 2*) ADIPISCING ELIT, SED DO EIUSMOD TEMPOR
    a34a1d0d (ipsum 2014-04-11 11:25:04 +0000 3*) INCIDIDUNT UT LABORE ET DOLORE MAGNA
    134200d1 (lorem 2014-04-10 08:54:46 +0000 4*) ALIQUA. UT ENIM AD MINIM VENIAM, QUIS
    c6eb3bfa (lorem 2014-08-11 23:15:57 +0000  5) NOSTRUD EXERCITATION ULLAMCO LABORIS
    0f0d17bd (dolor 2014-06-02 11:31:48 +0000 6*) NISI UT ALIQUIP EX EA COMMODO CONSEQUAT.

hyper-blame places a * next to any line where it has skipped over an ignored commit, so you know that the line in question has been changed (by an ignored commit) since the given person wrote it.

CAVEATS

When a line skips over an ignored commit, a guess is made as to which commit previously modified that line, but it is not always clear where the line came from. If the ignored commit makes lots of changes in close proximity, in particular adding/removing/reordering lines, then the wrong authors may be blamed for nearby edits.

For this reason, hyper-blame works best when the ignored commits are be limited to minor changes such as formatting and renaming, not refactoring or other more invasive changes.

SEE ALSO

git-blame(1)

CHROMIUM DEPOT_TOOLS

Part of the chromium depot_tools(7) suite. These tools are meant to assist with the development of chromium and related projects. Download the tools from here[1].

NOTES

1.  here
    https://chromium.googlesource.com/chromium/tools/depot_tools